// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('ggnresearch', ['ionic', 'ggnresearch.controllers', 'ggnresearch.directive', 'ggnresearch.factory', 'chart.js'])

.run(function($ionicPlatform, $rootScope, $timeout, $ionicHistory, $window, $state, $ionicPopup, $ionicSideMenuDelegate, FactoryFun) {
	$ionicPlatform.ready(function() {
		// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
		// for form inputs)
		if (window.cordova && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
			cordova.plugins.Keyboard.disableScroll(true);

		}
		if (window.StatusBar) {
			// org.apache.cordova.statusbar required
			StatusBar.styleDefault();
		}
	});

	$rootScope.backButtonTapToExit = true;

	$ionicPlatform.registerBackButtonAction(function(event) {
		if ($ionicSideMenuDelegate.isOpenLeft()) {
			$ionicSideMenuDelegate.toggleLeft();

		} else if($rootScope.backButtonTapToExit){

			if (!($state.params.page == 'search.html' || $state.params.page == 'favorite.html') && ($state.params.url == 'nonetwork' || $state.params.url == 'logout_device' || $state.params.url == window.localStorage.getItem('ggn_default_ctrl'))) {

				$rootScope.backButtonTapToExit = false;
				FactoryFun.getToast("Tap again to exit...");
				$timeout(function(){
					$rootScope.backButtonTapToExit = true;
				},1500);
				return;
			} else if ($ionicHistory.backView() != null) {
				if (!($ionicHistory.backView().stateParams.url == 'nonetwork' || $ionicHistory.backView().stateParams.url == 'logout_device' || $ionicHistory.backView().stateParams.url == 'login' || $ionicHistory.backView().stateParams.url == 'app')) {
					if (!($state.params.url == 'nonetwork' || $state.params.url == 'logout_device' || $state.params.url == window.localStorage.getItem('ggn_default_ctrl'))) {
						$window.history.back();
					}
				}
			} else {
				$window.location.href = FactoryFun.checkUserValid() ? window.localStorage.getItem('ggn_default_url') : '#/app/login/login.html';
			}

		} else {
			navigator.app.exitApp();
		}
	}, 200);


	$rootScope.DeviceOnline = navigator.onLine;

	$scope.bindEvents = function(){
		// console.log('bindEvents')
		document.addEventListener("deviceready", $scope.onDeviceReady, false);
		document.addEventListener("offline", $scope.onOffline, false);
		document.addEventListener("online", $scope.onOnline, false);
		document.addEventListener("pause", $scope.onPause, false);
		document.addEventListener("resume", $scope.onResume, false);
	}


	$scope.onDeviceReady = function(){
		$scope.onOnline();
	}


	$scope.onOnline = function(){
		$rootScope.$apply(function() {
			$rootScope.DeviceOnline = true;
		})

		if (FactoryFun.checkUserValid()) {
			document.addEventListener("deviceready", $scope.get_payer_id, false);
			$scope.$on('generatingNotificationId', function(event, args) {
				if (args.notification_id) {
					$window.location.href = (window.localStorage.getItem('ggn_default_url') || window.localStorage.getItem('ggn_default_url') != '') ? window.localStorage.getItem('ggn_default_url') : '#/app/report_list/reports.html';
				}
			});
		} else {
			$window.location.href = '#/app/login/login.html';
			return;
		}

		$window.location.href = '#/app/login/login.html';
	}


	$scope.onOffline = function(){
		$rootScope.$apply(function() {
			$rootScope.DeviceOnline = false;
		})

		$window.location.href = '#/app/nonetwork/nonetwork.html';
		return;
	}


	$scope.onPause = function(){
		// $scope.bindEvents();
		// console.log('onPause')
	}


	$scope.onResume = function(){
		if (!$rootScope.DeviceOnline) {
			$scope.bindEvents();
		}
		// $window.location.reload();
		// console.log('onResume')
		// $window.location.href = FactoryFun.checkUserValid() ? '#/app/get_dashboard/dashboard.html' : '#/app/login/login.html';
		// $window.location.href = '#/app/login/login.html';
		// console.log('Devices resume');
	}

	$scope.bindEvents();


	$rootScope.$broadcast('generatingNotificationId', { 'notification_id' : false, });

	$rootScope.get_payer_id = function() {
		if ($rootScope.DeviceOnline) {
			$rootScope.$broadcast('generatingNotificationId', { 'notification_id' : false, });
			$rootScope.notification = $ionicPopup.alert({
				title : 'GGN Research',
				template: '<ion-spinner></ion-spinner><span>Please wait it may take some time.</span>',
				cssClass: 'text-center notification',
				buttons: [{
					text: 'OK',
					type: 'button button-brown',
				}]
			});

			var deregisterBackButton;
			deregisterBackButton = $ionicPlatform.registerBackButtonAction(function(e){}, 401);
			$rootScope.notification.then(function(res) {
				deregisterBackButton();
			});


			var notificationOpenedCallback = function(jsonData) {
				// window.alert('notificationOpenedCallback: ' + JSON.stringify(jsonData));
				// window.alert(JSON.stringify(jsonData.notification.payload.additionalData));
			};

			window.plugins.OneSignal
			.startInit("9f91595a-0692-11e5-ad77-336eeb0f3434", "162625503694")
			.handleNotificationOpened(notificationOpenedCallback)
			.inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.Notification)
			.endInit();

			window.plugins.OneSignal.getIds(function(ids) {
				// window.alert('getIds: ' + JSON.stringify(ids));  //ids.userId, ids.pushToken
				window.localStorage.setItem('app_player_id', ids.userId);
				$rootScope.$broadcast('generatingNotificationId', { 'notification_id' : true, });
				$timeout(function(){
					$rootScope.notification.close();
				}, 100);
			});
			$scope.$on("$ionicView.leave", function(event, data){
				$rootScope.notification && $rootScope.notification.close();
			});
			if ($rootScope.DeviceOnline) {
				$rootScope.notification && $rootScope.notification.close();
			}
		}
	}
})


.config(function($stateProvider, $urlRouterProvider, $compileProvider, $ionicConfigProvider) {
	$stateProvider

	.state('app', {
		url: '/app',
		cache: false,
		abstract: true,
		templateUrl: 'templates/menu.html',
		controller: 'appCtrl'
	})

	.state('app.{url}', {
		url: '/{url}/{page}',
		// cache: false,
		views: {
			'menuContent': {
				templateUrl : function($stateParams) {
					return "templates/"+$stateParams.page;
				},
				controllerProvider : function($stateParams) {
					return $stateParams.url+"Ctrl";
				}
			}
		}
	})

	.state('app.{url}/{pageId}', {
		url: '/{url}/{pageId}/{page}',
		// cache: false,
		views: {
			'menuContent': {
				templateUrl : function($stateParams) {
					return "templates/"+$stateParams.page;
				},
				controllerProvider : function($stateParams) {
					return $stateParams.url+"Ctrl";
				}
			}
		}
	})

	.state('app.{url}/{pageId}/{pageSubId}', {
		url: '/{url}/{pageId}/{pageSubId}/{page}',
		// cache: false,
		views: {
			'menuContent': {
				templateUrl : function($stateParams) {
					return "templates/"+$stateParams.page;
				},
				controllerProvider : function($stateParams) {
					return $stateParams.url+"Ctrl";
				}
			}
		}
	})

	$ionicConfigProvider.views.swipeBackEnabled(false);
	$ionicConfigProvider.views.maxCache(3);

	// console.log($ionicConfigProvider)

	$compileProvider.debugInfoEnabled(false);

	// if none of the above states are matched, use this as the fallback
	// $urlRouterProvider.otherwise('/app/login/login.html');
	$urlRouterProvider.otherwise('/app/app/menu.html');
});
