angular.module('ggnresearch.controllers', [])

.controller('appCtrl', function($scope, $window, $ionicSideMenuDelegate, $state, $timeout, $ionicHistory, FactoryFun) {

	$scope.toggleLeft = function() {
		$ionicSideMenuDelegate.toggleLeft();
	}

	$scope.goBack = function() {
		if ($ionicHistory.backView() != null) {
			if (!($ionicHistory.backView().stateParams.url == 'nonetwork' || $ionicHistory.backView().stateParams.url == 'logout_device' || $ionicHistory.backView().stateParams.url == 'login' || $ionicHistory.backView().stateParams.url == 'app')) {
				if (!($state.params.url == 'nonetwork' || $state.params.url == 'logout_device' || $state.params.url == window.localStorage.getItem('ggn_default_ctrl'))) {
					$window.history.back();
				}
			}
		} else {
			if (!($state.params.url == 'logout_device' || $state.params.url == 'nonetwork')) {
				$window.location.href = FactoryFun.checkUserValid() ? window.localStorage.getItem('ggn_default_url') : '#/app/login/login.html';
			}
		}
	};

	$scope.getMainMenu = function() {
		// window.localStorage.setItem('ggn_token', 766255);
		// window.localStorage.setItem('app_player_id', '50470700-a15b-4942-810e-afb42afd2d64');
		FactoryFun.sendAjax('get_main_menu', {}, true, true)
		.success(function(response){
			$scope.main_logo = {'background-image' : 'url('+response.main_logo+')'}
			$scope.subscription_types = response.subscription_types;
			$scope.user_name = response.user_name;
			$scope.user_email = response.user_email;
			$scope.main_menu = response.main_menu;
			window.localStorage.setItem('ggn_default_url', response.default_url ? response.default_url : '#/app/login/login.html');
			window.localStorage.setItem('ggn_default_ctrl', response.default_ctrl ? response.default_ctrl : 'login');
			window.localStorage.setItem('ggn_logout_time', response.logout_time ? response.logout_time : 60);
		})
	}

	$scope.getMainMenu();

	$scope.DocumentReady = function(){
		if (!FactoryFun.checkUserValid()) {
			if ($state.params.url != 'logout') {
				FactoryFun.logOut();
				return;
			}
		}
	}

	$(window).on('hashchange', function(event){
		$url = '#'+(event.originalEvent.newURL).split('#')[1];
		$.each($('.main-has-header ion-item'), function(index, val) {
			if ($(val).attr('href') == $url) {
				$(val).addClass('has-active');
				$(val).parents('.dropdown').prevAll('.sub_menu').addClass('has-active');
			} else {
				$(val).removeClass('has-active');
			}
		});
	});


	$scope.accordion = function(id) {
		$('.accordion-'+id+' .accordion-body').stop(true, false).slideToggle(500);
		$('.accordion-'+id+' i').toggleClass('ion-plus-round ion-minus-round');
	}

	$(document).on('click', 'a, button, .ripple-animation', function(event) {
		var ripple, style, top, left;

		if($(this).find(".ripple").length == 0){
			$(this).append("<span class='ripple'></span>");
		}

		ripple = $(this).find(".ripple");
		ripple.removeClass("animate");

		if(!ripple.height() && !ripple.width()){
			style = Math.max($(this).outerWidth(), $(this).outerHeight());
			ripple.css({height: style, width: style});
		}

		left = event.pageX - $(this).offset().left - ripple.width() / 2;
		top = event.pageY - $(this).offset().top - ripple.height() / 2;

		ripple.css({top: top+'px', left: left+'px'}).addClass("animate");
		setTimeout(function() {
			ripple.remove();
		}, 1200);
	});

})


.controller('loginCtrl', function($scope, $window, FactoryFun) {
	$scope.auth = this;
	$scope.getMainMenu();

	$scope.LogIn = function() {

		if (!$scope.auth.token) {
			FactoryFun.getAlert('Please enter token number');
		} else if (!$scope.auth.contact_no) {
			FactoryFun.getAlert('Please enter valid contact number');

		} else {
			var PostData = {
				token_no : $scope.auth.token,
				contact_no : $scope.auth.contact_no
			}

			FactoryFun.sendAjax('check_token', PostData, true, true)
			.success(function(response){
				window.localStorage.setItem('ggn_token', $scope.auth.token);
				if (response.status == 1) {
					FactoryFun.getAlert(response.message).then(function(){
						window.localStorage.setItem('ggn_default_url', response.default_url ? response.default_url : '#/app/report_list/reports.html');
						window.localStorage.setItem('ggn_default_ctrl', response.default_ctrl ? response.default_ctrl : 'report_list');

						if (ionic.Platform.isWebView()) {
							document.addEventListener("deviceready", $scope.get_payer_id, false);

							$scope.$on('generatingNotificationId', function(event, args) {
								if (args.notification_id) {
									$window.location.href = window.localStorage.getItem('ggn_default_url');
									$scope.getMainMenu();
								}
							});
						}

					})
				}
			})
		}
	}

	$scope.RequestToken = function() {
		$window.location.href = '#/app/request_token/request_token.html';
	}

	$scope.FreeCalenderUtilities = function() {
		$window.location.href = '#/app/get_calendar/calender.html';
	}

})


.controller('logout_deviceCtrl', function($scope, $ionicSideMenuDelegate, $window, $stateParams, $interval, FactoryFun) {
	$scope.auth = this;
	$scope.getMainMenu();
	$scope.StateParams = $stateParams.pageId;
	$scope.counter = null;

	if ($stateParams.pageId != 1) {
		FactoryFun.sendAjax('logout_device', {}, true, true).success(function(response){})
	}

	$scope.RetryNow = function(event) {

		FactoryFun.sendAjax('register_notification_id', {}, true, true)
		.success(function(response){
			if (response.status == 1) {
				window.localStorage.setItem('ggn_default_url', response.default_url ? response.default_url : '#/app/report_list/reports.html');
				window.localStorage.setItem('ggn_default_ctrl', response.default_ctrl ? response.default_ctrl : 'report_list');

				$window.location.href = window.localStorage.getItem('ggn_default_url');

			}
		})
		$('#force_logout').text('Force Logout');

		$scope.counter && $interval.cancel($scope.counter);
		$scope.Force_Logout = true;

	}

	$scope.Force_Logout = true;

	$scope.ForceLogout = function(event) {
		if ($scope.Force_Logout) {
			$scope.Force_Logout = false;

			var SecsCount = Number(window.localStorage.getItem('ggn_logout_time'));
			$('#force_logout').text(SecsCount+' Secs');

			$scope.counter = $interval(function() {
				SecsCount --;
				if (SecsCount <= 0) {
					FactoryFun.sendAjax('logout_device', {}, true, true)
					.success(function(response){
						if (response.status == 1) {
							$window.location.href = '#/app/logout_device/logout.html';
						}
					})

					$interval.cancel($scope.counter);
				}
				$('#force_logout').text(SecsCount+' Secs');
			}, 1000);
		}
	}

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		$('#force_logout').text('Force Logout');
		$scope.counter && $interval.cancel($scope.counter);
		$scope.Force_Logout = true;

	});

	$scope.toggleLeft = function() {
		return;
	};

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$ionicSideMenuDelegate.canDragContent(false);
	});

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		$ionicSideMenuDelegate.canDragContent(true);
	});

	$scope.RequestToken = function() {
		$window.location.href = '#/app/request_token/request_token.html';
	}

})


.controller('nonetworkCtrl', function($scope, $ionicSideMenuDelegate, $window, $ionicLoading, $timeout, FactoryFun) {

	if ($ionicSideMenuDelegate.isOpenLeft()) {
		$ionicSideMenuDelegate.toggleLeft();
	}

	$scope.tryAgain = function() {
		$window.location.reload();
	};

	$scope.toggleLeft = function() {
		return;
	};

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		$ionicSideMenuDelegate.canDragContent(false);
	});

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		$ionicSideMenuDelegate.canDragContent(true);
	});


})

.controller('request_tokenCtrl', function($scope, $window, FactoryFun) {
	$scope.auth = this;
	$scope.headerTitle = 'Request Token';

	$scope.RequestToken = function() {
		if (!$scope.auth.name) {
			FactoryFun.getAlert('Please enter full name');

		} else if (!$scope.auth.email) {
			FactoryFun.getAlert('Please enter valid email');

		} else if (!$scope.auth.contact_no) {
			FactoryFun.getAlert('Please enter valid contact number');

		} else if (!$scope.auth.city) {
			FactoryFun.getAlert('Please enter city');

		} else {
			var PostData = {
				name : $scope.auth.name,
				email : $scope.auth.email,
				contact_no : $scope.auth.contact_no,
				city : $scope.auth.city,
			}

			FactoryFun.sendAjax('request_token', PostData, true, true)
			.success(function(response){
				if (response.status == 2) {
					FactoryFun.getAlert(response.message).then(function(){
						$window.location.href = '#/app/login/login.html';
					})
				}
			})
		}
	}

})

.controller('sms_listCtrl', function($scope, $window, FactoryFun) {
	$scope.auth = this;
	$scope.page_no = 1;
	$scope.InfiniteData = $scope.LoadingType = $scope.Loading = true;
	$scope.sms_list = [];

	$scope.token = window.localStorage.getItem('ggn_token');

	function sms_list() {
		FactoryFun.sendAjax('sms_list', { 'page_no' : $scope.page_no }, $scope.Loading, $scope.LoadingType)
		.success(function(response){
			$scope.Loading = false;
			$scope.LoadingType = true;
			$scope.headerTitle = response.title;

			$scope.watermark_logo = response.watermark_logo;

			if (response.sms_list) {
				$scope.page_no ++;
				$scope.sms_list.push(response.sms_list);
			} else {
				$scope.InfiniteData = false;
			}

			$scope.$broadcast('scroll.infiniteScrollComplete');
		}).then(function(response) {
			$scope.InfiniteLoadMore = function(){
				sms_list();
			}
		})
	}

	sms_list();


	$scope.smsListRefresh = function() {
		$scope.page_no = 1;
		$scope.InfiniteData = $scope.Loading = $scope.LoadingType = true;
		$scope.sms_list = [];

		sms_list();
		$scope.$broadcast('scroll.refreshComplete');
	};

})


.controller('report_listCtrl', function($scope, $window, $stateParams, $filter, $timeout, $ionicHistory, FactoryFun) {
	$scope.auth = this;
	$scope.page_no = 1;
	$scope.InfiniteData = $scope.Loading = $scope.LoadingType = true;
	$scope.report_list = [];

	$scope.auth.start_date = new Date(new Date().getFullYear(), new Date().getMonth() - 1);
	$scope.auth.end_date = new Date();

	function report_list() {
		var PostData = {
			'fav' : ($stateParams.page == 'favorite.html') ? 1 : '',
			'page_no' : $scope.page_no,
			'tab_id' : ($stateParams.page == 'search.html') ? 'search' : $stateParams.pageId,
			'from_dt' : ($stateParams.page == 'search.html') ? $filter('date')($scope.auth.start_date, 'y-M-d') : '',
			'to_dt' : ($stateParams.page == 'search.html') ? $filter('date')($scope.auth.end_date, 'y-M-d') : '',
			'search' : ($stateParams.page == 'search.html') ? $scope.auth.search : '',
		}

		FactoryFun.sendAjax('get_report_list', PostData, $scope.Loading, $scope.LoadingType)
		.success(function(response){
			$scope.headerTitle = response.title;
			$scope.Loading = false;
			$scope.LoadingType = true;

			if (response.report_list) {
				$scope.page_no ++;
				$scope.report_list.push(response.report_list);
			} else {
				$scope.InfiniteData = false;
			}

			if ($scope.report_list.length == 1) {
				FactoryFun.getTutorial('report_list');
			}

			$scope.$broadcast('scroll.infiniteScrollComplete');
		}).then(function(response) {
			$scope.InfiniteLoadMore = function(){
				report_list();
			}
		})
	}

	$scope.Search = function(id){
		$scope.report_list = [];
		$scope.page_no = 1;
		$scope.InfiniteData = true;
		$scope.Loading = true;
		$scope.LoadingType = false;
		report_list();
		$scope.accordion(id);
	}

	$scope.backView = null;

	$(window).on('hashchange', function(event){
		$scope.backView = ((event.originalEvent.newURL).split('#/app/')[1]).split('/')[0];
	})

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		if ($scope.backView != 'report_view') {
			$scope.page_no = 1;
			$scope.report_list = [];
			report_list();
		}
	})

	$scope.reportListRefresh = function() {
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.$on('scroll.refreshComplete', function(event, args) {
		$scope.report_list = [];
		$scope.page_no = 1;
		$scope.InfiniteData = $scope.Loading = $scope.LoadingType = true;
		report_list();
	});

	$scope.SetFavorite = function(id) {

		var favorite = ($('#'+id).find('i').attr('data-fav') == 1) ? 0 : 1;
		$('#'+id).find('i').attr('data-fav', favorite);

		FactoryFun.sendAjax('mark_report', { 'fav' : favorite, 'rep_id' : id }, false, true)
		.success(function(response){
			if (response.status == 1) {
				if (favorite == 1) {
					$('#'+id).find('i').fadeIn(300);
					FactoryFun.getToast('Report added to your favorite page.');
				} else {
					$('#'+id).find('i').fadeOut(300);
					FactoryFun.getToast('Report removed to your favorite page.');
				}
			}
		})
	}

	$scope.RemoveFavorite = function(id) {
		var favorite = ($('#'+id).find('i').attr('data-fav') == 1) ? 0 : 1;
		FactoryFun.sendAjax('mark_report', { 'fav' : favorite, 'rep_id' : id }, false, true)
		.success(function(response){
			if (response.status == 1) {
				FactoryFun.getToast('Report removed to your favorite page.');
				$('#'+id).removeClass('ripple-animation').css('min-height', 'auto').slideUp('slow');
			}
		})
	}

	$scope.ViewDetails = function(id) {
		$window.location.href = '#/app/report_view/'+id+'/report_view.html';
		$('.item.ripple-animation.simple-item-thumbnail-left').css('animation', 'none');
	}


})


.controller('report_viewCtrl', function($scope, $window, $stateParams, FactoryFun) {

	$scope.pageId = $stateParams.pageId;

	$scope.$on("$ionicView.beforeEnter", function(){
		FactoryFun.sendAjax('get_reports_images', { 'report_id' : $stateParams.pageId}, false, true)
		.success(function(response){
			$scope.headerTitle = response.title;
			$scope.list = response.list;

			if (response.list.length > 0) {
				setTimeout(function() {
					$('#view_'+$stateParams.pageId+' .swiper-slide .image_0').append('<img src="'+$scope.list[0]+'" />');
					new RTP.PinchZoom($('#view_'+$stateParams.pageId+' .swiper-slide .image_0'), {});

					if ($scope.list.length > 1) {
						$('#view_'+$stateParams.pageId+' .swiper-slide .image_1').append('<img src="'+$scope.list[1]+'" />');
						new RTP.PinchZoom($('#view_'+$stateParams.pageId+' .swiper-slide .image_1'), {});
					}
				}, 1000);
			}

			FactoryFun.sendAjax('mark_report', { 'read' : 1, 'rep_id' : $stateParams.pageId }, false, false);
			$('#'+$stateParams.pageId).css('background-color', '#F7F7F7');
			$('#'+$stateParams.pageId).find('h2').css('font-weight', 'normal');

		})
	})

	$scope.$on("$ionicSlides.slideChangeStart", function(event, data){
		$scope.activeIndex = data.slider.activeIndex + 1;
		if (($scope.list.length > $scope.activeIndex) && data.slider.swipeDirection == 'next' && $('.swiper-slide .image_'+$scope.activeIndex).find('img').length == 0) {
			$('#view_'+$stateParams.pageId+' .swiper-slide .image_'+$scope.activeIndex).append('<img src="'+$scope.list[$scope.activeIndex]+'" />');
			new RTP.PinchZoom($('#view_'+$stateParams.pageId+' .swiper-slide .image_'+$scope.activeIndex), {});
		}
	});



})

.controller('lq_exchange_listCtrl', function($scope, $window, $ionicModal, $interval, $state, FactoryFun) {
	$scope.auth = this;
	$scope.page_no = 1;
	$scope.ggn_token = window.localStorage.getItem('ggn_token');

	$scope.options = {
		pagination: false,
		slidesPerView: 5
	}

	$scope.interval_time = 12000;
	FactoryFun.sendAjax('lq_exchange_list', {}, false, false).success(function(response){
		$scope.tab_list = response.tab_list;
		$scope.interval_time = parseInt(response.market_quotes_refresh_rate);
	});

	function lq_livequotes(id) {
		FactoryFun.sendAjax('lq_livequotes', { 'exchange' : $scope.exchange }, true, true)
		.success(function(response){
			$scope.headerTitle = response.title;
			$scope.live_quotes = response.live_quotes;
			$scope.live_quotes_heading = response.live_quotes_heading;
			$scope.modalTitle = response.live_quotes_detail_heading;
		})
		$('.liveQuotes').removeClass('actives');
		$('.liveQuotes.'+id).addClass('actives');
		$('.hidden').addClass('hide');
		$('.icon-arrow').removeClass('ion-arrow-up-b').addClass('ion-arrow-down-b');
	}

	$scope.exchange = 1;
	$scope.liveQuotes = function(id) {
		$scope.exchange = id;
		lq_livequotes(id);
	};

	lq_livequotes($scope.exchange);

	$scope.reportListRefresh = function() {
		lq_livequotes($scope.exchange);
		$scope.$broadcast('scroll.refreshComplete');
	};

	$scope.intervalOption = $interval(function() {
		if ($state.params.url == 'lq_exchange_list') {
			lq_livequotes($scope.exchange);
		} else {
			$interval.cancel($scope.intervalOption);
		}
	}, $scope.interval_time);

	$scope.$on("$ionicView.beforeLeave", function(event, data){
		$interval.cancel($scope.intervalOption);
	});

	$scope.SetFavorite = function(id) {
		favorite = ($('#'+id).attr('data-fav') == 1) ? 0 : 1;
		$('#'+id).attr('data-fav', favorite);

		FactoryFun.sendAjax('lq_mark_fav', { 'fav' : favorite, 'cmd_id' : id }, false, true)
		.success(function(response){
			if (response.status == 1) {
				if (favorite == 1) {
					FactoryFun.getToast('Quote added to favorites.');
					$('#'+id+' i').removeClass('ion-android-star-outline').addClass('ion-android-star');

				} else {
					FactoryFun.getToast('Quote removed from favorites.');
					$('#'+id+' i').removeClass('ion-android-star').addClass('ion-android-star-outline');

				}
			}
		})
	}

	$scope.ShowMore = function(id) {
		$window.location.href = '#/app/get_market_chart/'+id+'/graph.html';
	}

	$ionicModal.fromTemplateUrl('ticker-modal', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	});
	$scope.openModal = function(id) {
		angular.forEach($scope.live_quotes, function(item){
			if (item.lq_id == id) {
				$scope.quotes_detail = item;
			}
		})
		$scope.modal.show();
	};
	$scope.closeModal = function() {
		$scope.modal.hide();
	};
	$scope.closeChart = function() {
		$('#line').closest('tr').addClass('hide');
		$('#line').remove();
	};

})


.controller('get_market_chartCtrl', function($scope, $window, $stateParams, FactoryFun) {

	FactoryFun.sendAjax($stateParams.url, { 'lq_id' : $stateParams.pageId }, true, true)
		.success(function(response){
			$scope.headerTitle = response.title;
			$scope.labels = response.lq_month;
			$scope.line_data = [response.lq_close_yesterday];
			$scope.chart_date_title = response.chart_date_title;
		})

	Chart.defaults.global.colors = ['#dd4b39'];
	$scope.datasetOverride = [{fill: true}];
	$scope.chart_options = {
		responsive: true,
		scales: {
            xAxes: [{
            	display: false,
                ticks: {
                    autoSkip: false,
                    maxRotation: 85,
                    minRotation: 85
                }
            }]
        }
	};
})

.controller('parity_calculatorCtrl', function($scope, $window, FactoryFun) {
	$scope.auth = this;

	$scope.CalculatorBlur = function() {
		if ($scope.auth.apc_commodity_rate == '') {
			$scope.auth.apc_commodity_rate = 0;
		}
		if ($scope.auth.apc_exchange_rate == '') {
			$scope.auth.apc_exchange_rate = 0;
		}
		$scope.Calculator();
	}

	$scope.Calculator = function() {
		var costing = 0;
		costing = parseFloat($scope.auth.apc_commodity_rate) * parseFloat($scope.auth.apc_exchange_rate);

		if(parseInt($scope.auth.apc_duty_fixed) == 1){
			costing += parseFloat($scope.auth.apc_import_duty);
		} else {
			costing = costing + (costing * parseFloat($scope.auth.apc_import_duty) / 100);
		}

		costing += parseFloat($scope.auth.apc_import_expense);
		$scope.Costing = 'Landed Cost &#x20B9; : ' + costing.toFixed(0) + ' PMT';
	}

	$scope.commodity = function(id){
		angular.forEach($scope.parity_calculator, function(item, index) {
			if (item.apc_id == id) {
				$scope.auth.apc_commodity_rate = item.apc_commodity_rate;
				$scope.auth.apc_exchange_rate = item.apc_exchange_rate;
				$scope.auth.apc_import_duty = item.apc_import_duty;
				$scope.auth.apc_import_expense = item.apc_import_expense;
				$scope.auth.apc_duty_fixed = item.apc_duty_fixed;
			}
		})
		$scope.Calculator();
	}

	FactoryFun.sendAjax('parity_calculator', {}, true, true)
	.success(function(response){
		$scope.parity_calculator = response.data;
		$scope.headerTitle = response.title;
		if (response.data) {
			$scope.auth.apc_commodity = response.data[0].apc_id;
			$scope.commodity(response.data[0].apc_id);
		}
	})
})


.controller('conversion_listCtrl', function($scope, $window, $ionicModal, FactoryFun) {
	$scope.auth = this;


	FactoryFun.sendAjax('conversion_list', {}, true, true)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.html = response.html;
	})

	$ionicModal.fromTemplateUrl('list-modal', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	});
	$scope.openModal = function(id) {
		FactoryFun.sendAjax('conversion_details', { 'con_id' : id }, true, true)
		.success(function(response){
			if (response.status == 1) {
				$scope.con_detail = response.con_detail;
				$scope.modalTitle = response.title;
				$scope.modal.show();
			}
		})
	};
	$scope.closeModal = function() {
		$scope.modal.hide();
	};
})


.controller('cbot_listCtrl', function($scope, $window, $ionicModal, FactoryFun) {
	$scope.auth = this;


	FactoryFun.sendAjax('cbot_list', {}, true, true)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.html = response.html;
	})

	$ionicModal.fromTemplateUrl('list-modal', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	});
	$scope.openModal = function(id) {
		FactoryFun.sendAjax('conversion_details', { 'con_id' : id }, true, true)
		.success(function(response){
			if (response.status == 1) {
				$scope.con_detail = response.con_detail;
				$scope.modalTitle = response.title;
				$scope.modal.show();
			}
		})
	};
	$scope.closeModal = function() {
		$scope.modal.hide();
	};
})


.controller('wayment_listCtrl', function($scope, $window, $ionicModal, FactoryFun) {
	$scope.auth = this;

	FactoryFun.sendAjax('wayment_list', {}, true, true)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.html = response.html;
	})

	$ionicModal.fromTemplateUrl('list-modal', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	});
	$scope.openModal = function(id) {
		FactoryFun.sendAjax('wayment_details', { 'con_id' : id }, true, true)
		.success(function(response){
			if (response.status == 1) {

				angular.forEach($scope.conversion_list, function(item, index){
					if (item.con_id == id) {
						$scope.modalTitle = item.con_title;
					}
				})

				$scope.con_detail = response.con_detail;
				$scope.modal.show();
			}
		})
	};
	$scope.closeModal = function() {
		$scope.modal.hide();
	};
})


.controller('page_detailsCtrl', function($scope, $window, $stateParams, FactoryFun) {
	$scope.auth = this;


	FactoryFun.sendAjax('page_details', { 'id' : $stateParams.pageId}, true, true)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.html = response.html;
	})
})


.controller('settings_tab_listCtrl', function($scope, $window, $stateParams, FactoryFun) {
	$scope.auth = this;


	FactoryFun.sendAjax('settings_tab_list', {}, true, true)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.tab_list = response.tab_list;
	})


	$scope.SetDefault = function(id) {
		var status = $('#is_default_'+id).attr('data-status') == 1 ? 0 : 1;
		$('#is_default_'+id).attr('data-status', status);

		if ($('#is_blocked_'+id).attr('data-status') == 1) {
			$('#is_blocked_'+id).attr('data-status', 0);
			FactoryFun.sendAjax('settings_tab_update', { 'tab_id' : id, 'is_blocked' : 0 }, false, true)
			.success(function(response){
				if (response.status == 1) {
					$('#is_blocked_'+id).toggleClass('ion-android-lock text-brown icon-activated ion-android-unlock text-grey');
				}
			})
		}

		FactoryFun.sendAjax('settings_tab_update', { 'tab_id' : id, 'is_default' : status }, false, true)
		.success(function(response){
			if (response.status == 1) {
				if (status == 1) {
					FactoryFun.getToast('Report added to default page.');
				} else {
					FactoryFun.getToast('Report removed from default page.');
				}
				$('#is_default_'+id).toggleClass('ion-android-checkbox text-brown icon-activated ion-android-checkbox-outline-blank text-grey');
			}
		})
	}


	$scope.SetBlocked = function(id) {
		var status = $('#is_blocked_'+id).attr('data-status') == 1 ? 0 : 1;
		$('#is_blocked_'+id).attr('data-status', status);

		if ($('#is_default_'+id).attr('data-status') == 1) {
			$('#is_default_'+id).attr('data-status', 0);
			FactoryFun.sendAjax('settings_tab_update', { 'tab_id' : id, 'is_default' : 0 }, false, true)
			.success(function(response){
				if (response.status == 1) {
					$('#is_default_'+id).toggleClass('ion-android-checkbox text-brown icon-activated ion-android-checkbox-outline-blank text-grey');
				}
			})
		}

		FactoryFun.sendAjax('settings_tab_update', { 'tab_id' : id, 'is_blocked' : status }, false, true)
		.success(function(response){
			if (response.status == 1) {
				if (status == 1) {
					FactoryFun.getToast('Report block successfully.');
				} else {
					FactoryFun.getToast('Report unblock successfully.');
				}
				$('#is_blocked_'+id).toggleClass('ion-android-lock text-brown icon-activated ion-android-unlock text-grey');
			}
		})
	}
})


.controller('default_startup_screenCtrl', function($scope, $window, FactoryFun) {
	$scope.headerTitle = 'Default Screen & Device';
	$scope.auth = this;

	$scope.defaultScreen = window.localStorage.getItem('ggn_default_ctrl');

	$scope.DefaultScreen = function(id) {
		FactoryFun.sendAjax('set_default_startup_screen', { 'default_option' : id }, true, false)
		.success(function(response){
			if (response.status == 1) {
				window.localStorage.setItem('ggn_default_url', response.default_url ? response.default_url : '#/app/report_list/reports.html');
				window.localStorage.setItem('ggn_default_ctrl', response.default_ctrl ? response.default_ctrl : 'report_list');
				$scope.defaultScreen = window.localStorage.getItem('ggn_default_ctrl');
				FactoryFun.getAlert(response.message);
			}
		})
	}


	$scope.Default = function(check) {
		FactoryFun.sendAjax('set_notification_device', { 'status' : check ? 'check' : 'update' }, true, check ? true : false)
		.success(function(response){
			$scope.match = response.match;
			$scope.flash_status = response.flash_status;
			$scope.reports_status = response.reports_status;
			$scope.ticker_status = response.ticker_status;
			if (response.status == 1) {
				FactoryFun.getAlert(response.message).then(function(){
					$window.location.href = window.localStorage.getItem('ggn_default_url');
				})
			}
		})
	}

	$scope.Default('check');
})


.controller('myinfoCtrl', function($scope, $window, FactoryFun) {
	$scope.auth = this;

	FactoryFun.sendAjax('myinfo', {}, true, true)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.html = response.html;
	})
})


.controller('add_suggestionCtrl', function($scope, $window, FactoryFun) {
	$scope.headerTitle = 'Suggestions';
	$scope.auth = this;

	$scope.submit = function() {
		if ($scope.auth.suggestion) {
			FactoryFun.sendAjax('add_suggestion', { 'suggestion' : $scope.auth.suggestion }, true, false)
			.success(function(response){
				if (response.status == 1) {
					FactoryFun.getAlert(response.message).then(function(){
						$window.location.href = $window.localStorage.getItem('ggn_default_url');
					})
				}
			})
		}
	}

})


.controller('rp_activations_todayCtrl', function($scope, $window, FactoryFun) {
	$scope.auth = this;

	FactoryFun.sendAjax('rp_activations_today', {}, true, false)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.html = response.html;
	})

})


.controller('rp_token_requestsCtrl', function($scope, $window, FactoryFun) {
	$scope.auth = this;

	FactoryFun.sendAjax('rp_token_requests', {}, true, false)
	.success(function(response){
		$scope.headerTitle = response.title;
		$scope.html = response.html;
	})


})


.controller('new_flash_messagesCtrl', function($scope, $window, $ionicPopup, $filter, FactoryFun) {
	$scope.headerTitle = 'New Flash Message';
	$scope.auth = this;

	$scope.userValid = $scope.disable_input = false;

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		if (!window.localStorage.getItem('ggn_um_id') || window.localStorage.getItem('ggn_um_id') == null || window.localStorage.getItem('ggn_um_id') == undefined) {

			var loginPopup = $ionicPopup.show({
				title: 'Log In',
				template:
				'<div class="select-box" style="margin-bottom: 10px;"><input type="text" class="text-brown" style="background-color:transparent" ng-model="auth.username" ng-disabled="disable_input" placeholder="Username"></div>'+
				'<div class="select-box" style="margin-bottom: 10px;"><input type="password" class="text-brown" style="background-color:transparent" ng-model="auth.password" ng-disabled="disable_input" placeholder="Password"></div>'+
				'<div class="text-center" ng-show="show_loading"><ion-spinner style="stroke: #a03535;fill: #a03535;"></ion-spinner></div>'+
				'<p style="margin-bottom: -10px !important;color:red;" class="text-center" ng-show="error_btn" ng-bind-html="error_text"></p>',
				scope: $scope,
				buttons: [{
					text: 'Cancel',
					type: 'button-grey',
					onTap: function(e) {
						loginPopup.close();
						$window.location.href = $window.localStorage.getItem('ggn_default_url');
					}},{
						text: 'Log In',
						type: 'button-brown',
						onTap: function(e) {
							e.preventDefault();
							if (($scope.auth.username != '' && $scope.auth.username != undefined) && ($scope.auth.password != '' && $scope.auth.password != undefined)) {
								$scope.disable_input = $scope.show_loading = true;
								$scope.error_btn = false;

								FactoryFun.sendAjax('check_flash_login',{ 'username' : $scope.auth.username, 'password' : $scope.auth.password }, false, false)
								.success(function(response){
									$scope.disable_input = $scope.show_loading = false;
									if (response.status == 1) {
										window.localStorage.setItem('ggn_um_id', response.um_id);
										loginPopup.close();
										$scope.userValid = true;
									} else {
										$scope.error_btn = true;
										$scope.error_text = 'Wrong username and password.<br />Please try again.';
									}
								});
							} else {
								e.preventDefault();
								$scope.error_btn = true;

								if (!$scope.auth.username){
									$scope.error_text = 'Please enter username.';
								} else if (!$scope.auth.password) {
									$scope.error_text = 'Please enter password.';
								}

							}
						}
					}]
				});
			loginPopup.then(function(response){
				if (!$scope.userValid) {
					loginPopup.close();
					$window.location.href = $window.localStorage.getItem('ggn_default_url');
				}
			});
		}


		$scope.auth.sms_type_id = '';
		$scope.auth.sms_story = '';
		$scope.auth.sms_email = '';
		$scope.auth.sms_send_sms = '';
		$scope.auth.sms_free = '';
		$scope.auth.status = '';

		FactoryFun.sendAjax('get_flash_messages', {}, true, false)
		.success(function(response){
			$scope.sms_type_master = response.sms_type_master;
			$scope.auth.sms_type_id = response.sms_type_master[0].smt_id;
			$scope.auth.status = true;
		})
	});


	$scope.submit = function() {

		var PostData = {
			sms_type_id : $scope.auth.sms_type_id,
			sms_story : $scope.auth.sms_story,
			sms_email : $scope.auth.sms_email ? 1 : 0,
			sms_send_sms : $scope.auth.sms_send_sms ? 1 : 0,
			sms_free : $scope.auth.sms_free ? 1 : 0,
			status : $scope.auth.status ? 1 : 0,
		}

		FactoryFun.sendAjax('add_flash_messages', PostData, true, true);
	}


})


.controller('get_calendarCtrl', function($scope, $window, $http, FactoryFun) {
	$scope.auth = this;

	function get_calendar(month, year) {
		FactoryFun.sendAjax('get_calendar', { 'month' : month, 'year' : year }, true, true)
		.success(function(response){
			$scope.headerTitle = response.title;
			$scope.htmlheader = response.htmlheader;
			$scope.htmlbody = response.htmlbody;
			$scope.yearly_events = response.yearly_events;
		})
	}

	get_calendar('', '')

	$scope.changeDate = function(month, year) {
		get_calendar(month, year)
	}

	$scope.calenderDetail = function(id) {
		angular.forEach($scope.yearly_events, function(item){
			if (item.hol_id == id) {
				var header = item.hol_is_holiday == 1 ? 'HOLIDAY' : 'INFORMATION';
				var body = '<div style="font-size: 16px;">' + item.hol_title + '<strong style="display: block;margin: 10px 0 0px;">Exchanges:</strong>' + (item.flags ? item.flags : '') + '</div>';
				FactoryFun.getAlert(header, body, 'text-left')
			}
		})
	}

})

.controller('get_demo_tokens_kitCtrl', function($stateParams, $scope, $window, $http, $ionicPopup, FactoryFun) {

	$scope.auth = this;
	$scope.userValid = $scope.disable_input = false;

	$scope.$on("$ionicView.beforeEnter", function(event, data){
		if (!window.localStorage.getItem('ggn_um_id') || window.localStorage.getItem('ggn_um_id') == null || window.localStorage.getItem('ggn_um_id') == undefined) {

			var loginPopup = $ionicPopup.show({
				title: 'Log In',
				template:
				'<div class="select-box" style="margin-bottom: 10px;"><input type="text" class="text-brown" style="background-color:transparent" ng-model="auth.username" ng-disabled="disable_input" placeholder="Username"></div>'+
				'<div class="select-box" style="margin-bottom: 10px;"><input type="password" class="text-brown" style="background-color:transparent" ng-model="auth.password" ng-disabled="disable_input" placeholder="Password"></div>'+
				'<div class="text-center" ng-show="show_loading"><ion-spinner style="stroke: #a03535;fill: #a03535;"></ion-spinner></div>'+
				'<p style="margin-bottom: -10px !important;color:red;" class="text-center" ng-show="error_btn" ng-bind-html="error_text"></p>',
				scope: $scope,
				buttons: [{
					text: 'Cancel',
					type: 'button-grey',
					onTap: function(e) {
						loginPopup.close();
						$window.location.href = $window.localStorage.getItem('ggn_default_url');
					}},{
						text: 'Log In',
						type: 'button-brown',
						onTap: function(e) {
							e.preventDefault();
							if (($scope.auth.username != '' && $scope.auth.username != undefined) && ($scope.auth.password != '' && $scope.auth.password != undefined)) {
								$scope.disable_input = $scope.show_loading = true;
								$scope.error_btn = false;

								FactoryFun.sendAjax('check_flash_login',{ 'username' : $scope.auth.username, 'password' : $scope.auth.password }, false, false)
								.success(function(response){
									$scope.disable_input = $scope.show_loading = false;
									if (response.status == 1) {
										window.localStorage.setItem('ggn_um_id', response.um_id);
										loginPopup.close();
										$scope.userValid = true;
									} else {
										$scope.error_btn = true;
										$scope.error_text = 'Wrong username and password.<br />Please try again.';
									}
								});
							} else {
								e.preventDefault();
								$scope.error_btn = true;

								if (!$scope.auth.username){
									$scope.error_text = 'Please enter username.';
								} else if (!$scope.auth.password) {
									$scope.error_text = 'Please enter password.';
								}

							}
						}
					}]
				});
			loginPopup.then(function(response){
				if (!$scope.userValid) {
					loginPopup.close();
					$window.location.href = $window.localStorage.getItem('ggn_default_url');
				}
			});
		}

		FormData = {};
		FactoryFun.sendAjax($stateParams.url, FormData)
		.success(function(response) {
			$scope.headerTitle = response.title;
			$scope.salesman_master = response.salesman_master;
			$scope.auth.dt_salesman_id = response.salesman_master[0].sm_id;
			$scope.subscription_types = response.subscription_types;
			$scope.auth.dt_subscription_type_id = response.subscription_types[0].sbt_id;
		})
	});

	$scope.demo_token_submit = function() {

		var PostData = {
			dt_salesman_id : $scope.auth.dt_salesman_id ? $scope.auth.dt_salesman_id : '',
			dt_subscription_type_id : $scope.auth.dt_subscription_type_id ? $scope.auth.dt_subscription_type_id : '',
			dt_company_name : $scope.auth.dt_company_name ? $scope.auth.dt_company_name : '',
			dt_contact_person : $scope.auth.dt_contact_person ? $scope.auth.dt_contact_person : '',
			dt_mobile_no : $scope.auth.dt_mobile_no ? $scope.auth.dt_mobile_no : '',
			dt_email : $scope.auth.dt_email ? $scope.auth.dt_email : ''
		}

		FactoryFun.sendAjax('add_demo_tokens_kit', PostData)
		.success(function(response) {
			if (response.emp_device_token) {
				FactoryFun.getAlert(response.emp_device_token_title, response.emp_device_token);
			}
			$scope.auth.dt_salesman_id = $scope.auth.dt_subscription_type_id = $scope.auth.dt_company_name = '';
			$scope.auth.dt_contact_person = $scope.auth.dt_mobile_no = $scope.auth.dt_email = '';
		})

	}

})