angular.module('ggnresearch.directive', [])

.directive('ggnHeader', function() {
	return {
		restrict : 'E',
		replace : true,
		template : '<ion-header-bar class="bar-header ggn-header bar" align-title="left" ng-init="DocumentReady()">'
		+ '<button class="text-white menu-button button-icon ion ion-navicon" on-tap="toggleLeft()"></button>'
		+ '<button class="text-white back-button button-icon ion ion-android-arrow-back" on-tap="goBack()"></button>'
		+ '<div class="title text-white title-left" ng-if="!headerTitle">GGN Research</div>'
		+ '<div class="title text-white title-left" ng-if="headerTitle">{{headerTitle}}</div>'
		+ '</ion-header-bar>'
	}
})


.directive('ggnHeaderFree', function() {
	return {
		restrict : 'E',
		replace : true,
		template : '<ion-header-bar class="bar-header ggn-header bar" align-title="left" ng-init="DocumentReadyFree()">'
		+ '<button class="text-white menu-button button-icon ion ion-navicon" on-tap="toggleLeft()"></button>'
		+ '<button class="text-white back-button button-icon ion ion-android-arrow-back" on-tap="goBack()"></button>'
		+ '<div class="title text-white title-left" ng-if="!headerTitle">GGN Research</div>'
		+ '<div class="title text-white title-left" ng-if="headerTitle">{{headerTitle}}</div>'
		+ '</ion-header-bar>'
	}
})


.directive('ggnHeaderModal', function() {
	return {
		restrict : 'E',
		replace : true,
		template :
		  '<ion-header-bar class="bar-header ggn-header bar" align-title="left" ng-init="ModalReady()">'
		+ '<button class="text-white button-icon ion ion-close-round" on-tap="closeModal()"></button>'
		+ '<div class="title text-white" ng-if="!modalTitle">GGN Research</div>'
		+ '<div class="title text-white" ng-if="modalTitle">{{ modalTitle }}</div>'
		+ '</ion-header-bar>'
	}
})


.directive('ggnInfiniteScroll', function() {
	return {
		restrict : 'E',
		replace : true,
		template : '<ion-infinite-scroll ng-class="Loading && '+"hide"+'" ng-if="InfiniteData" distance="5%" on-infinite="InfiniteLoadMore()"></ion-infinite-scroll>'
	}
})


.directive('compileHtml', function ($compile) {
	return function(scope, element, attrs) {
		scope.$watch(
			function(scope) {
				return scope.$eval(attrs.compileHtml);
			},
			function(value) {
				element.html(value);
				$compile(element.contents())(scope);
			}
		);
	};
})


.directive("limitTo", function() {
	return {
		restrict: 'A',
		link: function(scope, elem, attrs) {
			var limit = parseInt(attrs.limitTo);
			angular.element(elem).on("keypress", function(e) {
				if (this.value.length == limit) e.preventDefault();
				if (this.value.slice(0,1) == 0) this.value = '';
			});
		}
	}
})


.filter('trusted', function($sce) {
	return function(text) {
		return $sce.trustAsHtml(text);
	};
})