angular.module('ggnresearch.factory', [])

.factory('FactoryFun', function($http, $window, $ionicPopup, $timeout, $ionicLoading, $ionicModal, $rootScope, $stateParams, $compile, $filter, $ionicHistory, $state ){

	$scope = $rootScope;

	function getAlert(title, msg, alertClass){
		return $ionicPopup.alert({
			title : msg ? title : 'GGN Research',
			template: msg ? msg : title,
			cssClass: alertClass ? alertClass : 'text-center',
			buttons: [{
				text: 'OK',
				type: 'button button-brown'
			}]
		});
	};

	function getConfirm(msg, okBtn, cancelBtn){
		if (!msg) { return; }
		return $ionicPopup.confirm({
			title: 'GGN Research',
			template: msg,
			cancelText: cancelBtn ? cancelBtn : 'Cancel',
			cancelType: 'button-grey',
			okText: okBtn ? okBtn : 'Ok',
			okType: 'button-brown',
		}).then(function(response) {
			return response;
		});
	};

	function checkUserValid(){
		return (!window.localStorage.getItem('ggn_token') || !window.localStorage.getItem('app_player_id')) ? false : true;
	};

	function getUserData(){

		data = {
			token : window.localStorage.getItem('ggn_token') ? window.localStorage.getItem('ggn_token') : '',

			player_id : window.localStorage.getItem('app_player_id') ? window.localStorage.getItem('app_player_id') : '',
			um_id : window.localStorage.getItem('ggn_um_id') ? window.localStorage.getItem('ggn_um_id') : '',
			version : '2.25.00',

			device_type : getPlatform() ? getPlatform() : 'Not Found',
			device_version : ionic.Platform.version() ? ionic.Platform.version() : 'Not Found',
			device_name : ionic.Platform.device().model ? ionic.Platform.device().model : 'Not Found',
			from_app : 1
		}

		return data;
	};

	function getPlatform() {
		var platform = ionic.Platform.platform().toLowerCase();
		return (platform == 'android') ? 'A'
		: (platform == 'ios') ? 'I'
		: (platform == 'blackberry') ? 'B'
		: (platform == 'windows' || platform == 'windowsphone') ? 'W'
		: (platform == 'win32' || platform == 'win64') ? 'D'
		: (platform == 'macintel') ? 'M' : 'O';
	}


	function sendAjax(sendApi, PostData, Loading, LoadingType){
		if ($scope.DeviceOnline) {
			if (Loading) {
				if (LoadingType) {
					$('ion-side-menu-content .pane').addClass('loading')
				} else {
					$ionicLoading.show();
				}
			}

			PostData = angular.extend(PostData, getUserData());

			return $http({
				method: "POST",
				//url: 'http://192.168.7.175/ggnweb/sys_api_app/'+sendApi,
				 url: 'https://indrjt.in/ggnweb/sys_api_app/'+sendApi,
				data: $.param(PostData),
				headers: { "Content-Type": "application/x-www-form-urlencoded; charset=utf-8" }
			})

			.success(function(response){
				$timeout(function(){
					if (Loading) {
						if (LoadingType) {
							$('ion-side-menu-content .pane').addClass('loaded').removeClass('loading');
						} else {
							$ionicLoading.hide();
						}
					}
				}, 400)

				if (response.status == 0) {
					if (response.message) {
						$ionicPopup.alert({
							title : 'GGN Research',
							template: response.message,
							buttons: [{
								text: 'OK',
								type: 'button button-brown'
							}]
						});
					}
					logOut();
					return;

				} else if (response.status == 3) {
					if (response.message) {
						if (response.update) {
							$ionicPopup.confirm({
								title: 'GGN Research',
								template: response.message,
								cancelText: 'Later',
								cancelType: 'button-grey',
								okText: 'Update',
								okType: 'button-brown',
							}).then(function(res) {
								if (res) {
									window.open(response.update, '_system', 'location=no');
									if (response.url) {
										$window.location.href = response.url;
									}
								}
							})
							return;
						}

						var ggnPopup = $ionicPopup.alert({
							title : 'GGN Research',
							template: response.message,
							buttons: [{
								text: 'OK',
								type: 'button button-brown'
							}]
						})
						ggnPopup.then(function() {
							if (response.back) {
								if (response.back == 'default') {
									$window.location.href = checkUserValid() ? window.localStorage.getItem('ggn_default_url') : '#/app/login/login.html';
									return;
								}

								if ($ionicHistory.backView() != null) {
									if (!($ionicHistory.backView().stateParams.url == 'nonetwork' || $ionicHistory.backView().stateParams.url == 'logout_device' || $ionicHistory.backView().stateParams.url == 'login' || $ionicHistory.backView().stateParams.url == 'app')) {
										if (!($state.params.url == 'nonetwork' || $state.params.url == 'logout_device' || $state.params.url == window.localStorage.getItem('ggn_default_ctrl'))) {
											$window.history.back();
										}
									}
								} else {
									if (!($state.params.url == 'logout_device' || $state.params.url == 'nonetwork')) {
										$window.location.href = FactoryFun.checkUserValid() ? window.localStorage.getItem('ggn_default_url') : '#/app/login/login.html';
									}
								}

							} else if (response.url) {
								$window.location.href = response.url;
							}
						})
					} else if (response.back) {

						if (response.back == 'default') {
							$window.location.href = checkUserValid() ? window.localStorage.getItem('ggn_default_url') : '#/app/login/login.html';
							return;
						}

						if ($ionicHistory.backView() != null) {
							if (!($ionicHistory.backView().stateParams.url == 'nonetwork' || $ionicHistory.backView().stateParams.url == 'logout_device' || $ionicHistory.backView().stateParams.url == 'login' || $ionicHistory.backView().stateParams.url == 'app')) {
								if (!($state.params.url == 'nonetwork' || $state.params.url == 'logout_device' || $state.params.url == window.localStorage.getItem('ggn_default_ctrl'))) {
									$window.history.back();
								}
							}
						} else {
							if (!($state.params.url == 'logout_device' || $state.params.url == 'nonetwork')) {
								$window.location.href = FactoryFun.checkUserValid() ? window.localStorage.getItem('ggn_default_url') : '#/app/login/login.html';
							}
						}
					}
				}

			})

			.error(function(response, status){
				if (Loading) {
					if (LoadingType) {
						$('ion-side-menu-content .pane').addClass('loaded').removeClass('loading');
					} else {
						$ionicLoading.hide();
					}
				}

				if (status != 500) {
					getAlert('<p style="margin-bottom:5px;">We are unable to connect server.</p>Make sure your connected to the internet and please try again later.');
				}

			});

		} else {
			return ggnAjax = {
				success: function() {}
			};
		}
	}

	function getToast(msg){
		if (ionic.Platform.isWebView()) {
			window.plugins.toast.showWithOptions({
				message: msg,
				duration: "3000",
				position: "bottom",
				addPixelsY: -60,
				styling: {
					opacity: 0.7,
					cornerRadius: 16,
					textSize: 14
				}
			});
		} else {
			if ($('#toast').length == 0) {
				$('body').append('<div id="toast" style="position: absolute;left: 10%;right: 10%;bottom: -100px;z-index: 10;text-align: center;background-color: rgba(0,0,0,0.5);border-radius: 4px;padding: 10px 15px;"></div>');
			} else {
				$('#toast').css('bottom', '-100px');
				clearInterval(toastInterval);
			}

			$('#toast').html('<span style="color: #fff;">'+msg+'</span>');
			$('#toast').animate({'bottom': '50px'}, 300);

			toastInterval = setInterval(removeToast, 3000);

			function removeToast() {
				$('#toast').animate({'bottom': '-100px'}, 300);
				clearInterval(toastInterval);
			}
		}
	}

	var savedData = '';
	function storeData(storeData) {
		if (storeData) {
			savedData = storeData;
		} else {
			return savedData;
		}
	}


	function logOut() {

		$ionicHistory.clearHistory();
		$ionicHistory.clearCache();


		window.localStorage.removeItem('ggn_token');
		window.localStorage.removeItem('ggn_tutorial_report_list');
		window.localStorage.removeItem('ggn_status');
		window.localStorage.removeItem('app_player_id');

		window.location.href = '#/app/login/login.html';
		return;
	}


	function FocusBox(id) {
		$timeout(function() {
			var element = $window.document.getElementsByTagName('input')[id] ? $window.document.getElementsByTagName('input')[id] : $window.document.getElementsByTagName('select')[id];
			element && element.focus();
		});
	}

	function getTutorial(tutorialType) {
		if (window.localStorage.getItem('ggn_tutorial_'+tutorialType) != 'read') {
			if (tutorialType == 'report_list') {
				template  = '<div id="tutorial">';
				template += '<a id="tutorial-details" class="item simple-item-thumbnail-left">';
				template += '<div class="image-icon">';
				template += '<i id="tutorial-demo" data-fav="1"  class="ion-android-star">';
				template += '</i>';
				template += '<img src="img/tutorial.jpg">';
				template += '</div>';
				template += '<div class="content">';
				template += '<h2>GGN Research</h2>';
				template += '<p>GGN Research</p>';
				template += '</div>';
				template += '</a>';
				template += '<button id="SkipTutorial" class="button hide button-small button-brown">Skip Tutorial</button>';
				template += '<div id="tutorial-tool-tip">Tap here to add a report to favorites.</div>';
				template += '<img id="finger" width="30" src="img/click-1.svg">';
				template += '</div>';
				$('body').append(template);


				var Temp = 1;

				Tutorial = setInterval(function(){
					if (Temp == 1) {
						Temp = 2;
						$('#tutorial').addClass('step-1');
						$('#tutorial-demo').fadeOut();
						$('#tutorial-tool-tip').html('Tap again to remove a report from favorites.');
					} else if (Temp == 2) {
						Temp = 3;

						$('#tutorial').toggleClass('step-1 step-2');
						$('#tutorial-tool-tip').html('Tap here to view a report.');
					} else if (Temp == 3) {
						Temp = 4;
						$('#tutorial').toggleClass('step-2 step-3');
						$('#tutorial-tool-tip').html('Pull down list to refresh.');
						setTimeout(function() {
							$('#finger').addClass('active-top');
						}, 200);
					} else if (Temp == 4) {
						Temp = 5;
						setTimeout(function() {
							$('#finger').toggleClass('active-top active-left');
						}, 200);
						$('#tutorial-demo').fadeIn();
						$('#tutorial').toggleClass('step-3 step-4');
						$('#tutorial-tool-tip').html('Swipe from left to open navigation menu.');
					}else if (Temp == 5) {
						Temp = 1;
						$('#finger').removeClass('active-left');
						$('#tutorial-demo').fadeIn();
						$('#tutorial').removeClass('step-4')
						$('#tutorial-tool-tip').html('Tap here to add a report to favorites.');
						$('#tutorial').find('#SkipTutorial').fadeIn(500);
					}

				}, 3000);

				$('#tutorial').on('click', '#SkipTutorial', function(event) {
					$('#tutorial').fadeOut(500);
					clearInterval(Tutorial);
					window.localStorage.setItem('ggn_tutorial_'+tutorialType, 'read');
				});
			} else if (tutorialType == 'other') {
				//
			}

			$scope.$on("$ionicView.leave", function(event, data){
				$('#tutorial').fadeOut(500);
				clearInterval(Tutorial);
				window.localStorage.setItem('ggn_tutorial_'+tutorialType, 'read');
			})
		}
	}


	return {
		getAlert : getAlert,
		getConfirm : getConfirm,
		sendAjax : sendAjax,
		getToast : getToast,
		checkUserValid : checkUserValid,
		getPlatform : getPlatform,
		storeData : storeData,
		logOut : logOut,
		FocusBox : FocusBox,
		getTutorial : getTutorial
	}

})